VERSION 5.00
Object = "{4DE9E2A3-150F-11CF-8FBF-444553540000}#4.0#0"; "DlxOCX32.ocx"
Begin VB.Form Form1 
   Caption         =   "TimerTic Message from CTM"
   ClientHeight    =   2355
   ClientLeft      =   2655
   ClientTop       =   1815
   ClientWidth     =   4035
   LinkTopic       =   "Form1"
   ScaleHeight     =   2355
   ScaleWidth      =   4035
   Begin VB.TextBox txtInterval 
      Height          =   405
      Left            =   2040
      TabIndex        =   2
      Text            =   "1"
      Top             =   720
      Width           =   615
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Enabled         =   0   'False
      Height          =   375
      Left            =   360
      TabIndex        =   1
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "OK"
      Height          =   375
      Left            =   3000
      TabIndex        =   0
      Top             =   1800
      Width           =   855
   End
   Begin DlsrLib.DriverLINXSR SR 
      Left            =   3480
      Top             =   1080
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      BackColor       =   &H000000FF&
      Caption         =   " KEITHLEY "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   240
      Left            =   360
      TabIndex        =   5
      Top             =   240
      Width           =   1215
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H8000000E&
      Height          =   375
      Left            =   360
      TabIndex        =   4
      Top             =   1320
      Width           =   2535
   End
   Begin VB.Label Label1 
      Caption         =   "Interval (Seconds)"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1920
      TabIndex        =   3
      Top             =   480
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' tested in Win2K SP4 with CTM-05/A board
' using VB6 and CTM-850A01.0.0.2 version of DriverLINX
'
' A counter channel can be programmed to send a message, TimerTic,
' at a requested rate.  Since this uses Windows' messaging do not
' ask it to send a message faster than once per 10 msec.  At rates
' faster than this, the message queue will flood and mouse clicks,
' Windows Paint, etc will be blocked.

Private Sub cmdExit_Click()
' stop the active task
With SR
.Req_op = DL_STOP
.Refresh
End With
SR.Req_DLL_name = ""  ' unload the driver
End
End Sub

Private Sub cmdStart_Click()
Dim Interval As Single
txtInterval.Enabled = False
With SR
.Req_op = DL_START
.Req_subsystem = DL_CT
.Req_mode = DL_INTERRUPT
.Evt_Str_type = DL_COMMAND
.Evt_Stp_type = DL_COMMAND
.Evt_Tim_type = DL_RATEEVENT
.Evt_Tim_rateMode = DL_RATEGEN
.Evt_Tim_rateChannel = 0
.Evt_Tim_rateClock = DL_INTERNAL1  ' is a 1HHz or 5MHz timebase depending on DLinx Config
'
' but for ratePeriod longer than 16bit counter x timebase, DriverLINX will
' automatically calculate which other internal timebase to use, e.g. INTERNAL2..
' to INTERNAL5.  Without this feature, the interval could not be longer than
' the INTERNAL1 value x 65535 or 65 msec for 1MHz timebase
'
.Evt_Tim_ratePeriod = .DLSecs2Tics(.Evt_Tim_rateChannel, CSng(txtInterval.Text))
.Evt_Tim_ratePulses = 0  ' 0 = continuous task
.Evt_Tim_rateGate = DL_DISABLED
' if SR has no channels and no buffers = timer tic messages
.Sel_buf_N = 0
.Sel_chan_N = 0
.Refresh
End With
lblStatus.Caption = SR.Message
End Sub

Private Sub Form_Load()
With SR
.Req_DLL_name = "kmbctm$" ' $ on end will suppress Open Driver dialog
.Req_device = 0  ' make device number agree with DLinx config Panel
.Req_mode = DL_OTHER
.Req_subsystem = DL_DEVICE
.Req_op = DL_INITIALIZE
.Refresh
End With
If SR.Res_result = DL_NoErr Then
cmdStart.Enabled = True
Else
MsgBox "Unable to Initialize CTM, Device 0.  Verify you have a CTM board and it is device 0.", vbOKOnly
End If
End Sub


Private Sub SR_TimerTic(task As Integer, device As Integer, subsystem As Integer, mode As Integer)
Static Counter As Long
Counter = Counter + 1
lblStatus.Caption = Str(Counter) & " TimerTic Messages Processed"
End Sub
